#include "Main.h"
#undef CPXERR_NOT_FOR_MIP

// Problem constant
// Number of pattern
const uint16 NbPattern = 4 ;

int main(void)
{
   int status = 0 ;
   int Iter = 0 ;
   char CharTmp[TAILLESTR] ;

   // Declare environnement and linear problem.
   CPXENVptr master_env ;
   CPXLPptr master_lp ;
   
   // Environnement Cplex
   master_env = CPXopenCPLEX(&status) ;

   //----
   // Create problem : Master
   char master_ProbName[TAILLESTR] ;
   strcpy(master_ProbName, "Master") ;
   sprintf(CharTmp, "%d", Iter) ;
   strcat(master_ProbName, CharTmp) ;
   master_lp = CPXcreateprob(master_env, &status, master_ProbName) ;

   // Define objectif function type
   CPXchgobjsen(master_env, master_lp, CPX_MIN) ;
   // Define Prob type : LP, MILP,...
   CPXchgprobtype(master_env, master_lp, CPXPROB_LP) ;
   
   // Number of new constraints
   int master_rcnt = 4 ;
   // Right Hand constraint value
   double master_rhs[TAILLEROW] ;
   master_rhs[0] = 97 ;
   master_rhs[1] = 610 ;
   master_rhs[2] = 395 ;
   master_rhs[3] = 211 ;
   // Sense of each constrain.
   char master_sense[TAILLEROW] ;
   master_sense[0] = 'G' ;
   master_sense[1] = 'G' ;
   master_sense[2] = 'G' ;
   master_sense[3] = 'G' ;
   // Range of contraint if sense is a range ('R')
   double master_rngval[TAILLEROW] ;
   master_rngval[0] = 0 ;
   master_rngval[1] = 0 ;
   master_rngval[2] = 0 ;
   master_rngval[3] = 0 ;

   // Name of contraints
   char ** master_rowname ;
   master_rowname = new char*[TAILLEROW] ;

   for (uint16 i = 0 ; i<TAILLEROW ; i++)
   {
      master_rowname[i] = new char[TAILLESTR] ;
   }
   strcpy(master_rowname[0], "C1") ;
   strcpy(master_rowname[1], "C2") ;
   strcpy(master_rowname[2], "C3") ;
   strcpy(master_rowname[3], "C4") ;

   status = CPXnewrows(master_env, master_lp, master_rcnt, master_rhs, master_sense, master_rngval, master_rowname) ;
  

   // Number of column
   int master_ccnt = 3 ;
   // Number of nonzero constraint coefficient
   int master_nzcnt = 4 ;
   // Objective coef
   double master_obj[TAILLECOL] ;
   master_obj[0] = 1 ;
   master_obj[1] = 1 ;
   master_obj[2] = 1 ;
   // Array that specifies the nonzero elements of the columns being added
   int master_cmatbeg[TAILLECOL] ;
   master_cmatbeg[0] = 0 ;
   master_cmatbeg[1] = 2 ;
   master_cmatbeg[2] = 3 ;
   // Array that specifies the nonzero elements of the columns being added
   int master_cmatind[TAILLE] ;
   master_cmatind[0] = 1 ;
   master_cmatind[1] = 2 ;
   master_cmatind[2] = 0 ;
   master_cmatind[3] = 3 ;   
   // Coeficient constrain
   double master_cmatval[TAILLE] ;
   master_cmatval[0] = 1.0 ;
   master_cmatval[1] = 2.0 ;
   master_cmatval[2] = 1.0 ;
   master_cmatval[3] = 1.0 ;   
   // Lower bound
   double master_lb[TAILLECOL] ;
   master_lb[0] = 0.0 ;
   master_lb[1] = 0.0 ;
   master_lb[2] = 0.0 ;   
   // Upper bound
   double master_ub[TAILLECOL] ;
   master_ub[0] = CPX_INFBOUND ;
   master_ub[1] = CPX_INFBOUND ;
   master_ub[2] = CPX_INFBOUND ;
   // Column name
   char ** master_colname ;
   master_colname = new char*[TAILLECOL] ;
   for (uint16 i = 0 ; i<TAILLECOL ; i++)
   {
      master_colname[i] = new char[TAILLESTR] ;
   }
   strcpy(master_colname[0], "x1") ;
   strcpy(master_colname[1], "x2") ;
   strcpy(master_colname[2], "x3") ;

   status = CPXaddcols(master_env, master_lp, master_ccnt, master_nzcnt, master_obj, master_cmatbeg, 
                        master_cmatind, master_cmatval, master_lb, master_ub, master_colname) ;

   
  
   // Create problem : Slave
   // Declare environnement and linear problem.
   CPXENVptr slave_env ;
   slave_env = CPXopenCPLEX(&status) ;
      
   // Declare linear problem.
   CPXLPptr slave_lp ;
   char ProbNameSlave[TAILLESTR] ;
   strcpy(ProbNameSlave, "Slave") ;
   sprintf(CharTmp, "%d", Iter) ;
   strcat(ProbNameSlave, CharTmp) ;
   slave_lp = CPXcreateprob(slave_env, &status, ProbNameSlave) ;

   
   // Define objectif function type
   CPXchgobjsen(slave_env, slave_lp, CPX_MAX) ;
   double slave_objval = 0.0 ;
   // Define Prob type : LP, MILP,...
   CPXchgprobtype(slave_env, slave_lp, CPXPROB_MILP) ;
   
   // Number of new constraints
   int slave_rcnt = 1 ;
   // Right Hand constraint value
   double slave_rhs[TAILLEROW] ;
   slave_rhs[0] = 100 ;   
   // Sense of each constrain.
   char slave_sense[TAILLEROW] ;
   slave_sense[0] = 'L' ;   
   // Range of contraint if sense is a range ('R')
   double slave_rngval[TAILLEROW] ;
   slave_rngval[0] = 0 ;   

   // Name of contraints
   char ** slave_rowname ;
   slave_rowname = new char*[TAILLEROW] ;

   for (uint16 i = 0 ; i<TAILLEROW ; i++)
   {
      slave_rowname[i] = new char[TAILLESTR] ;
   }
   strcpy(slave_rowname[0], "L") ;   

   status = CPXnewrows(slave_env, slave_lp, slave_rcnt, slave_rhs, slave_sense, slave_rngval, slave_rowname) ;
  

   // Number of column
   int slave_ccnt = 4 ;
   // Number of nonzero constraint coefficient
   int slave_nzcnt = 4 ;
   // Objective coef
   double slave_obj[TAILLECOL] ;
   slave_obj[0] = 1.0 ;
   slave_obj[1] = 1.0 ;
   slave_obj[2] = 1.0 ;
   slave_obj[3] = 1.0 ;
   // Array that specifies the nonzero elements of the columns being added
   int slave_cmatbeg[TAILLECOL] ;
   slave_cmatbeg[0] = 0 ;
   slave_cmatbeg[1] = 1 ;
   slave_cmatbeg[2] = 2 ;
   slave_cmatbeg[3] = 3 ;
   // Array that specifies the nonzero elements of the ligne being added
   int slave_cmatind[TAILLE] ;
   slave_cmatind[0] = 0 ;
   slave_cmatind[1] = 0 ;
   slave_cmatind[2] = 0 ;
   slave_cmatind[3] = 0 ;   
   // Coeficient constrain
   double slave_cmatval[TAILLE] ;
   slave_cmatval[0] = 45.0 ;
   slave_cmatval[1] = 36.0 ;
   slave_cmatval[2] = 31.0 ;
   slave_cmatval[3] = 14.0 ;   
   // Lower bound
   double slave_lb[TAILLECOL] ;
   slave_lb[0] = 0.0 ;
   slave_lb[1] = 0.0 ;
   slave_lb[2] = 0.0 ;
   slave_lb[3] = 0.0 ;
   // Upper bound
   double slave_ub[TAILLECOL] ;
   slave_ub[0] = CPX_INFBOUND ;
   slave_ub[1] = CPX_INFBOUND ;
   slave_ub[2] = CPX_INFBOUND ;
   slave_ub[3] = CPX_INFBOUND ;
   // Column name
   char ** slave_colname ;
   slave_colname = new char*[TAILLECOL] ;
   for (uint16 i = 0 ; i<TAILLECOL ; i++)
   {
      slave_colname[i] = new char[TAILLESTR] ;
   }
   strcpy(slave_colname[0], "y1") ;
   strcpy(slave_colname[1], "y2") ;
   strcpy(slave_colname[2], "y3") ;
   strcpy(slave_colname[3], "y4") ;

   status = CPXaddcols(slave_env, slave_lp, slave_ccnt, slave_nzcnt, slave_obj, slave_cmatbeg, 
                        slave_cmatind, slave_cmatval, slave_lb, slave_ub, slave_colname) ;

   
   // Define variable type (for mip only)   
   int slave_indice[TAILLECOL] ;
   slave_indice[0] = 0 ;
   slave_indice[1] = 1 ;
   slave_indice[2] = 2 ;
   slave_indice[3] = 3 ;
   char slave_xctype[TAILLECOL] ;
   slave_xctype[0] = 'I' ;
   slave_xctype[1] = 'I' ;
   slave_xctype[2] = 'I' ;
   slave_xctype[3] = 'I' ;
   CPXchgctype(slave_env, slave_lp, slave_ccnt, slave_indice, slave_xctype) ;


     
   
   //--------------------
   // Start Generation de colonne   
   do
   {
      // Master problem
      // Turn on master environment
      CPXsetintparam(master_env, CPX_PARAM_SCRIND, CPX_ON) ;
      printf("\n\nMaster %d ------------------\n", Iter) ;
      // Write output file .lp
      char master_filename_str[TAILLESTR] ;
      strcpy(master_filename_str, "Master") ;
      sprintf(CharTmp, "%d.lp", Iter) ;
      strcat(master_filename_str, CharTmp) ;
      CPXwriteprob(master_env, master_lp, master_filename_str, NULL) ;   



      //-----
      // Resolution primal
      // Nombre de colonnes
      double master_objval = 0.0 ;
      uint16 master_NbCol = 0 ;
      master_NbCol = CPXgetnumcols (master_env, master_lp) ;

      // Optimisation lp
      CPXlpopt(master_env, master_lp) ;

      // Get Objectif value
      CPXgetobjval(master_env, master_lp, &master_objval) ;

      printf("Objectif value = %5.2f\n", master_objval) ;   

      // Get variables value
      double master_VariableValue[TAILLE] ;
      CPXgetx(master_env, master_lp, master_VariableValue, 0, master_NbCol - 1) ;

      char ** master_VariableNameTAB ;
      master_VariableNameTAB = new char*[master_NbCol] ;
      char master_VariableName[TAILLESTR] ;

      int master_Surplus = 0 ;
      CPXgetcolname(master_env, master_lp, master_VariableNameTAB, master_VariableName, TAILLESTR, 
         &master_Surplus, 0, master_NbCol - 1) ;

      for (uint16 i = 0 ; i<master_NbCol ; i++)
      {
         printf("%s = %5.2f\n", master_VariableNameTAB[i], master_VariableValue[i]) ;      
      }

      // Take reduced cost value
      int master_NbRow = CPXgetnumrows(master_env, master_lp) ;
      double master_ReducedCost[TAILLEROW] ;
      for (int i = 0 ; i<master_NbRow ; ++i)
      {
         master_ReducedCost[i] = 0.0 ;      
      }
      CPXgetpi(master_env, master_lp, master_ReducedCost, 0, master_NbRow-1) ;
      for (int i = 0 ; i<master_NbRow ; ++i)
      {
         printf("ReducedCost[%d] = %5.2f\n", i, master_ReducedCost[i]) ;      
      }



      //-----
      // Slave problem
      // Shuttle down master environnement
      CPXsetintparam(master_env, CPX_PARAM_SCRIND, CPX_OFF) ;  
      // Turn on slave environnement
      CPXsetintparam(slave_env, CPX_PARAM_SCRIND, CPX_ON) ;   
      printf("\n\nSlave %d ------------------\n", Iter) ;

      // Change objective coef
      for (uint16 i = 0 ; i<NbPattern ; ++i)
      {
         slave_obj[i] = master_ReducedCost[i] ;
      }

      CPXchgobj(slave_env, slave_lp, NbPattern, slave_indice, slave_obj) ;

      // Write output file .lp   
      char slave_filename_str[TAILLESTR] ;
      strcpy(slave_filename_str, "Slave") ;
      sprintf(CharTmp, "%d.lp", Iter) ;
      strcat(slave_filename_str, CharTmp) ;
      CPXwriteprob(slave_env, slave_lp, slave_filename_str, NULL) ;



      //----
      // Resolution slave
      uint16 slave_NbCol = 0 ;
      slave_NbCol = CPXgetnumcols (slave_env, slave_lp) ;

      // Optimisation lp
      CPXmipopt(slave_env, slave_lp) ;   

      // Get Objectif value
      CPXgetmipobjval(slave_env, slave_lp, &slave_objval) ;
      printf("Objectif value = %5.2f\n", slave_objval) ;   

      // Get variables value
      double slave_VariableValue[TAILLE] ;
      CPXgetmipx(slave_env, slave_lp, slave_VariableValue, 0, slave_NbCol - 1) ;

      char ** slave_VariableNameTAB ;
      slave_VariableNameTAB = new char*[slave_NbCol] ;
      char slave_VariableName[TAILLESTR] ;

      int slave_Surplus = 0 ;
      CPXgetcolname(slave_env, slave_lp, slave_VariableNameTAB, slave_VariableName, TAILLESTR, 
         &slave_Surplus, 0, slave_NbCol - 1) ;

      for (uint16 i = 0 ; i<slave_NbCol ; i++)
      {
         printf("%s = %5.2f\n", slave_VariableNameTAB[i], slave_VariableValue[i]) ;      
      }


      //-----
      // Add column to primal
      if (slave_objval>=1)
      {// if there a new column to add...
         // Number of column
         master_ccnt = 1 ;
         
         // Number of nonzero constraint coefficient         
         uint16 ind_master_cmatind = 0 ;
         master_nzcnt = 0 ;
         for (uint16 i = 0 ; i<NbPattern ; ++i)
         {
            if (slave_VariableValue[i] != 0)
            {
               master_nzcnt++ ;
               // Array that specifies the nonzero elements of the columns being added
               master_cmatind[ind_master_cmatind] = i ;
               // Coeficient constrain
               master_cmatval[0] = slave_VariableValue[i] ;
               ++ind_master_cmatind ;
            }            
         }

         // Objective coef         
         master_obj[0] = 1 ;
         // Array that specifies the nonzero elements of the columns being added
         master_cmatbeg[0] = 0 ;
         // Lower bound
         master_lb[0] = 0.0 ;
         // Upper bound
         master_ub[0] = CPX_INFBOUND ;
         // Column name         
         strcpy(master_colname[0], "x") ;
         sprintf(CharTmp, "%d", master_NbCol+1) ;
         strcat(master_colname[0], CharTmp) ;
         
         // Add new column
         status = CPXaddcols(master_env, master_lp, master_ccnt, master_nzcnt, master_obj, master_cmatbeg, 
            master_cmatind, master_cmatval, master_lb, master_ub, master_colname) ;
      }

      // Shuttle down slave environnement
      CPXsetintparam(slave_env, CPX_PARAM_SCRIND, CPX_OFF) ;    
      Iter++ ;
   }while (slave_objval>1 && Iter < 20 ) ;



   //-----
   // Resolution primal en entier   
   CPXsetintparam(master_env, CPX_PARAM_SCRIND, CPX_ON) ; 
   printf("\n\nFinal solution %d ------------------\n", Iter) ;
   // Change type : LP => MILP
   CPXchgprobtype(master_env, master_lp, CPXPROB_MILP) ;

   // Nombre de colonnes
   double master_objval = 0.0 ;
   uint16 master_NbCol = 0 ;
   master_NbCol = CPXgetnumcols (master_env, master_lp) ;

   // Define variable type (for mip only)
   int master_indice[TAILLECOL] ;
   for (uint16 i = 0 ;i<=master_NbCol ; ++i)
   {
      master_indice[i] = i ;  
   }
   char master_xctype[TAILLECOL] ;
   for (uint16 i = 0 ; i<=master_NbCol ; ++i)
   {
      master_xctype[i] = 'I' ;    
   }
   CPXchgctype(master_env, master_lp, master_NbCol, master_indice, master_xctype) ;

   // Optimisation lp
   CPXmipopt(master_env, master_lp) ;

   // Get Objectif value
   CPXgetmipobjval(master_env, master_lp, &master_objval) ;

   printf("Objectif value = %5.2f\n", master_objval) ;   

   // Get variables value
   double master_VariableValue[TAILLE] ;
   CPXgetmipx(master_env, master_lp, master_VariableValue, 0, master_NbCol - 1) ;

   char ** master_VariableNameTAB ;
   master_VariableNameTAB = new char*[master_NbCol] ;
   char master_VariableName[TAILLESTR] ;

   int master_Surplus = 0 ;
   CPXgetcolname(master_env, master_lp, master_VariableNameTAB, master_VariableName, TAILLESTR, 
      &master_Surplus, 0, master_NbCol - 1) ;

   for (uint16 i = 0 ; i<master_NbCol ; i++)
   {
      printf("%s = %5.2f\n", master_VariableNameTAB[i], master_VariableValue[i]) ;      
   }




   //-----
   // Free space alloc  
   for (uint16 i = 0 ; i<TAILLECOL ; i++)
   {
      delete master_rowname[i] ;
   }
   delete master_rowname ;
   for (uint16 i = 0 ; i<TAILLECOL ; i++)
   {
      delete master_colname[i] ;
   }
   delete master_colname ;
   
   for (uint16 i = 0 ; i<TAILLECOL ; i++)
   {
      delete slave_rowname[i] ;
   }
   delete slave_rowname ;
   for (uint16 i = 0 ; i<TAILLECOL ; i++)
   {
      delete slave_colname[i] ;
   }
   delete slave_colname ;

   //delete VariableNameTAB ;
   CPXfreeprob(master_env, &master_lp) ;
   CPXfreeprob(slave_env, &slave_lp) ;
   CPXcloseCPLEX(&master_env) ;
   CPXcloseCPLEX(&slave_env) ;
   return 0 ;
}




